diff --git a/okhttp/src/main/java/okhttp3/RealCall.java b/okhttp/src/main/java/okhttp3/RealCall.java
index 9e4933d871..addecfdd1b 100644
--- a/okhttp/src/main/java/okhttp3/RealCall.java
+++ b/okhttp/src/main/java/okhttp3/RealCall.java
@@ -111,7 +111,7 @@ static RealCall newRealCall(OkHttpClient client, Request originalRequest, boolea
   }
 
   private void captureCallStackTrace() {
-    transmitter.setCallStackTrace(
+    transmitter.initCallStackTrace(
         Platform.get().getStackTraceForCloseable("response.body().close()"));
   }
 
diff --git a/okhttp/src/main/java/okhttp3/internal/Transmitter.java b/okhttp/src/main/java/okhttp3/internal/Transmitter.java
index 436c421467..8cd81b78e1 100644
--- a/okhttp/src/main/java/okhttp3/internal/Transmitter.java
+++ b/okhttp/src/main/java/okhttp3/internal/Transmitter.java
@@ -74,7 +74,7 @@ public Transmitter(OkHttpClient client, Call call) {
     this.eventListener = client.eventListenerFactory().create(call);
   }
 
-  public void setCallStackTrace(@Nullable Object callStackTrace) {
+  public void initCallStackTrace(@Nullable Object callStackTrace) {
     this.callStackTrace = callStackTrace;
   }
 
@@ -133,8 +133,8 @@ public boolean isCanceled() {
     return canceled;
   }
 
-  public void streamFailed(@Nullable IOException e) {
-    streamAllocation.streamFailed(e);
+  public void releaseStreamForException() {
+    streamAllocation.releaseStreamForException();
   }
 
   public void noNewStreamsOnConnection() {
@@ -190,29 +190,49 @@ public void callFailed(IOException e) {
   }
 
   public void writeRequestHeaders(Request request) throws IOException {
-    eventListener.requestHeadersStart(call);
-    streamAllocation.codec().writeRequestHeaders(request);
-    eventListener.requestHeadersEnd(call, request);
+    try {
+      eventListener.requestHeadersStart(call);
+      streamAllocation.codec().writeRequestHeaders(request);
+      eventListener.requestHeadersEnd(call, request);
+    } catch (IOException e) {
+      streamAllocation.streamFailed(e);
+      throw e;
+    }
   }
 
   public Sink createRequestBody(Request request) throws IOException {
+    long contentLength = request.body().contentLength();
     eventListener.requestBodyStart(call);
-    Sink rawRequestBody = streamAllocation.codec()
-        .createRequestBody(request, request.body().contentLength());
-    return new RequestBodySink(rawRequestBody, request.body().contentLength());
+    Sink rawRequestBody = streamAllocation.codec().createRequestBody(request, contentLength);
+    return new RequestBodySink(rawRequestBody, contentLength);
   }
 
   public void flushRequest() throws IOException {
-    streamAllocation.codec().flushRequest();
+    try {
+      streamAllocation.codec().flushRequest();
+    } catch (IOException e) {
+      streamAllocation.streamFailed(e);
+      throw e;
+    }
   }
 
   public void finishRequest() throws IOException {
-    streamAllocation.codec().finishRequest();
+    try {
+      streamAllocation.codec().finishRequest();
+    } catch (IOException e) {
+      streamAllocation.streamFailed(e);
+      throw e;
+    }
   }
 
   public Response.Builder readResponseHeaders(boolean expectContinue) throws IOException {
-    eventListener.responseHeadersStart(call);
-    return streamAllocation.codec().readResponseHeaders(expectContinue);
+    try {
+      eventListener.responseHeadersStart(call);
+      return streamAllocation.codec().readResponseHeaders(expectContinue);
+    } catch (IOException e) {
+      streamAllocation.streamFailed(e);
+      throw e;
+    }
   }
 
   public void responseHeadersEnd(Response response) {
@@ -220,13 +240,18 @@ public void responseHeadersEnd(Response response) {
   }
 
   public ResponseBody openResponseBody(Response response) throws IOException {
-    streamAllocation.eventListener.responseBodyStart(streamAllocation.call);
-    String contentType = response.header("Content-Type");
-    HttpCodec codec = streamAllocation.codec();
-    long contentLength = codec.reportedContentLength(response);
-    Source rawSource = codec.openResponseBodySource(response);
-    ResponseBodySource source = new ResponseBodySource(rawSource, contentLength);
-    return new RealResponseBody(contentType, contentLength, Okio.buffer(source));
+    try {
+      streamAllocation.eventListener.responseBodyStart(streamAllocation.call);
+      String contentType = response.header("Content-Type");
+      HttpCodec codec = streamAllocation.codec();
+      long contentLength = codec.reportedContentLength(response);
+      Source rawSource = codec.openResponseBodySource(response);
+      ResponseBodySource source = new ResponseBodySource(rawSource, contentLength);
+      return new RealResponseBody(contentType, contentLength, Okio.buffer(source));
+    } catch (IOException e) {
+      streamAllocation.streamFailed(e);
+      throw e;
+    }
   }
 
   public DeferredTrailers deferredTrailers() {
@@ -256,6 +281,9 @@ public Socket releaseAndAcquire(RealConnection newConnection) {
   }
 
   public void responseBodyComplete(long bytesRead, IOException e) {
+    if (e != null) {
+      streamAllocation.streamFailed(e);
+    }
     if (streamAllocation != null) {
       streamAllocation.responseBodyComplete(bytesRead, e);
     }
@@ -279,8 +307,22 @@ public void responseBodyComplete(long bytesRead, IOException e) {
         throw new ProtocolException("expected " + contentLength
             + " bytes but received " + (bytesReceived + byteCount));
       }
-      super.write(source, byteCount);
-      this.bytesReceived += byteCount;
+      try {
+        super.write(source, byteCount);
+        this.bytesReceived += byteCount;
+      } catch (IOException e) {
+        streamAllocation.streamFailed(e);
+        throw e;
+      }
+    }
+
+    @Override public void flush() throws IOException {
+      try {
+        super.flush();
+      } catch (IOException e) {
+        streamAllocation.streamFailed(e);
+        throw e;
+      }
     }
 
     @Override public void close() throws IOException {
@@ -290,7 +332,12 @@ public void responseBodyComplete(long bytesRead, IOException e) {
         throw new ProtocolException("unexpected end of stream");
       }
       eventListener.requestBodyEnd(call, bytesReceived);
-      super.close();
+      try {
+        super.close();
+      } catch (IOException e) {
+        streamAllocation.streamFailed(e);
+        throw e;
+      }
     }
   }
 
diff --git a/okhttp/src/main/java/okhttp3/internal/connection/RealConnection.java b/okhttp/src/main/java/okhttp3/internal/connection/RealConnection.java
index c3e1594948..cf5fa20a6a 100644
--- a/okhttp/src/main/java/okhttp3/internal/connection/RealConnection.java
+++ b/okhttp/src/main/java/okhttp3/internal/connection/RealConnection.java
@@ -30,7 +30,6 @@
 import java.security.cert.X509Certificate;
 import java.util.ArrayList;
 import java.util.List;
-import java.util.concurrent.TimeUnit;
 import javax.annotation.Nullable;
 import javax.net.ssl.SSLPeerUnverifiedException;
 import javax.net.ssl.SSLSession;
@@ -55,19 +54,19 @@
 import okhttp3.internal.Util;
 import okhttp3.internal.Version;
 import okhttp3.internal.http.HttpCodec;
-import okhttp3.internal.http.HttpHeaders;
 import okhttp3.internal.http1.Http1Codec;
+import okhttp3.internal.http2.ConnectionShutdownException;
 import okhttp3.internal.http2.ErrorCode;
 import okhttp3.internal.http2.Http2Codec;
 import okhttp3.internal.http2.Http2Connection;
 import okhttp3.internal.http2.Http2Stream;
+import okhttp3.internal.http2.StreamResetException;
 import okhttp3.internal.platform.Platform;
 import okhttp3.internal.tls.OkHostnameVerifier;
 import okhttp3.internal.ws.RealWebSocket;
 import okio.BufferedSink;
 import okio.BufferedSource;
 import okio.Okio;
-import okio.Source;
 
 import static java.net.HttpURLConnection.HTTP_OK;
 import static java.net.HttpURLConnection.HTTP_PROXY_AUTH;
@@ -105,6 +104,12 @@
    */
   public boolean noNewStreams;
 
+  /**
+   * If true there was a problem establishing this connection that may be due to route chosen. Once
+   * true this is always true. Guarded by {@link #connectionPool}.
+   */
+  public int routeFailureCount;
+
   public int successCount;
   public int refusedStreamCount;
 
@@ -524,7 +529,7 @@ public boolean supportsUrl(HttpUrl url) {
 
   public HttpCodec newCodec(OkHttpClient client, Interceptor.Chain chain) throws SocketException {
     if (http2Connection != null) {
-      return new Http2Codec(client, chain, http2Connection);
+      return new Http2Codec(client, this, chain, http2Connection);
     } else {
       socket.setSoTimeout(chain.readTimeoutMillis());
       source.timeout().timeout(chain.readTimeoutMillis(), MILLISECONDS);
@@ -534,6 +539,7 @@ public HttpCodec newCodec(OkHttpClient client, Interceptor.Chain chain) throws S
   }
 
   public RealWebSocket.Streams newWebSocketStreams(Transmitter transmitter) {
+    noNewStreams();
     return new RealWebSocket.Streams(true, source, sink) {
       @Override public void close() throws IOException {
         transmitter.responseBodyComplete(-1L, null);
@@ -610,6 +616,40 @@ public boolean isMultiplexed() {
     return http2Connection != null;
   }
 
+  /**
+   * Track a failure using this connection. This may prevent both the connection and its route from
+   * being used for future streams.
+   */
+  void trackFailure(@Nullable IOException e) {
+    assert (Thread.holdsLock(connectionPool));
+
+    if (e instanceof StreamResetException) {
+      ErrorCode errorCode = ((StreamResetException) e).errorCode;
+      if (errorCode == ErrorCode.REFUSED_STREAM) {
+        // Retry REFUSED_STREAM errors once on the same connection.
+        refusedStreamCount++;
+        if (refusedStreamCount > 1) {
+          noNewStreams = true;
+          routeFailureCount++;
+        }
+      } else if (errorCode != ErrorCode.CANCEL) {
+        // Keep the connection for CANCEL errors. Everything else wants a fresh connection.
+        noNewStreams = true;
+        routeFailureCount++;
+      }
+    } else if (!isMultiplexed() || e instanceof ConnectionShutdownException) {
+      noNewStreams = true;
+
+      // If this route hasn't completed a call, avoid it for new connections.
+      if (successCount == 0) {
+        if (e != null) {
+          connectionPool.connectFailed(route, e);
+        }
+        routeFailureCount++;
+      }
+    }
+  }
+
   @Override public Protocol protocol() {
     return protocol;
   }
diff --git a/okhttp/src/main/java/okhttp3/internal/connection/RealConnectionPool.java b/okhttp/src/main/java/okhttp3/internal/connection/RealConnectionPool.java
index 0d5ce5dbb9..7b4cd10360 100644
--- a/okhttp/src/main/java/okhttp3/internal/connection/RealConnectionPool.java
+++ b/okhttp/src/main/java/okhttp3/internal/connection/RealConnectionPool.java
@@ -16,7 +16,9 @@
  */
 package okhttp3.internal.connection;
 
+import java.io.IOException;
 import java.lang.ref.Reference;
+import java.net.Proxy;
 import java.net.Socket;
 import java.util.ArrayDeque;
 import java.util.ArrayList;
@@ -260,4 +262,16 @@ private int pruneAndGetAllocationCount(RealConnection connection, long now) {
 
     return references.size();
   }
+
+  /** Track a bad route in the route database. Other routes will be attempted first. */
+  public void connectFailed(Route failedRoute, IOException failure) {
+    // Tell the proxy selector when we fail to connect on a fresh connection.
+    if (failedRoute.proxy().type() != Proxy.Type.DIRECT) {
+      Address address = failedRoute.address();
+      address.proxySelector().connectFailed(
+          address.url().uri(), failedRoute.proxy().address(), failure);
+    }
+
+    routeDatabase.failed(failedRoute);
+  }
 }
diff --git a/okhttp/src/main/java/okhttp3/internal/connection/RouteSelector.java b/okhttp/src/main/java/okhttp3/internal/connection/RouteSelector.java
index 40752ce23d..1c48449a4d 100644
--- a/okhttp/src/main/java/okhttp3/internal/connection/RouteSelector.java
+++ b/okhttp/src/main/java/okhttp3/internal/connection/RouteSelector.java
@@ -105,20 +105,6 @@ public Selection next() throws IOException {
     return new Selection(routes);
   }
 
-  /**
-   * Clients should invoke this method when they encounter a connectivity failure on a connection
-   * returned by this route selector.
-   */
-  public void connectFailed(Route failedRoute, IOException failure) {
-    if (failedRoute.proxy().type() != Proxy.Type.DIRECT && address.proxySelector() != null) {
-      // Tell the proxy selector when we fail to connect on a fresh connection.
-      address.proxySelector().connectFailed(
-          address.url().uri(), failedRoute.proxy().address(), failure);
-    }
-
-    routeDatabase.failed(failedRoute);
-  }
-
   /** Prepares the proxy servers to try. */
   private void resetNextProxy(HttpUrl url, Proxy proxy) {
     if (proxy != null) {
diff --git a/okhttp/src/main/java/okhttp3/internal/connection/StreamAllocation.java b/okhttp/src/main/java/okhttp3/internal/connection/StreamAllocation.java
index 08d627674c..b954349ba0 100644
--- a/okhttp/src/main/java/okhttp3/internal/connection/StreamAllocation.java
+++ b/okhttp/src/main/java/okhttp3/internal/connection/StreamAllocation.java
@@ -32,9 +32,6 @@
 import okhttp3.internal.Transmitter.TransmitterReference;
 import okhttp3.internal.Util;
 import okhttp3.internal.http.HttpCodec;
-import okhttp3.internal.http2.ConnectionShutdownException;
-import okhttp3.internal.http2.ErrorCode;
-import okhttp3.internal.http2.StreamResetException;
 
 import static okhttp3.internal.Util.closeQuietly;
 
@@ -82,8 +79,8 @@
   public final Call call;
   public final EventListener eventListener;
   private final Object callStackTrace;
+
   private RouteSelector.Selection routeSelection;
-  private Route route;
 
   // State guarded by connectionPool.
   private final RouteSelector routeSelector;
@@ -91,6 +88,7 @@
   private boolean reportedAcquired;
   private boolean released;
   private boolean canceled;
+  private boolean hasStreamFailure;
   private HttpCodec codec;
 
   public StreamAllocation(Transmitter transmitter, RealConnectionPool connectionPool,
@@ -100,7 +98,8 @@ public StreamAllocation(Transmitter transmitter, RealConnectionPool connectionPo
     this.address = address;
     this.call = call;
     this.eventListener = eventListener;
-    this.routeSelector = new RouteSelector(address, routeDatabase(), call, eventListener);
+    this.routeSelector = new RouteSelector(
+        address, connectionPool.routeDatabase, call, eventListener);
     this.callStackTrace = callStackTrace;
   }
 
@@ -121,7 +120,11 @@ public HttpCodec newStream(
         codec = resultCodec;
         return resultCodec;
       }
+    } catch (RouteException e) {
+      streamFailed(e.getLastConnectException());
+      throw e;
     } catch (IOException e) {
+      streamFailed(e);
       throw new RouteException(e);
     }
   }
@@ -171,6 +174,10 @@ private RealConnection findConnection(int connectTimeout, int readTimeout, int w
       if (codec != null) throw new IllegalStateException("codec != null");
       if (canceled) throw new IOException("Canceled");
 
+      Route previousRoute = connection != null && connection.routeFailureCount == 0
+          ? connection.route()
+          : null;
+
       // Attempt to use an already-allocated connection. We need to be careful here because our
       // already-allocated connection may have been restricted from creating new streams.
       releasedConnection = connection;
@@ -195,7 +202,7 @@ private RealConnection findConnection(int connectTimeout, int readTimeout, int w
           foundPooledConnection = true;
           result = connection;
         } else {
-          selectedRoute = route;
+          selectedRoute = previousRoute;
         }
       }
     }
@@ -231,7 +238,6 @@ private RealConnection findConnection(int connectTimeout, int readTimeout, int w
           if (connectionPool.transmitterAcquirePooledConnection(address, transmitter, route)) {
             foundPooledConnection = true;
             result = connection;
-            this.route = route;
             break;
           }
         }
@@ -244,7 +250,7 @@ private RealConnection findConnection(int connectTimeout, int readTimeout, int w
 
         // Create a connection and assign it to this allocation immediately. This makes it possible
         // for an asynchronous cancel() to interrupt the handshake we're about to do.
-        route = selectedRoute;
+        hasStreamFailure = false;
         result = new RealConnection(connectionPool, selectedRoute);
         transmitterAcquireConnection(result, false);
       }
@@ -259,7 +265,7 @@ private RealConnection findConnection(int connectTimeout, int readTimeout, int w
     // Do TCP + TLS handshakes. This is a blocking operation.
     result.connect(connectTimeout, readTimeout, writeTimeout, pingIntervalMillis,
         connectionRetryEnabled, call, eventListener);
-    routeDatabase().connected(result.route());
+    connectionPool.routeDatabase.connected(result.route());
 
     Socket socket = null;
     synchronized (connectionPool) {
@@ -319,12 +325,10 @@ public HttpCodec codec() {
     }
   }
 
-  private RouteDatabase routeDatabase() {
-    return connectionPool.routeDatabase;
-  }
-
   public Route route() {
-    return route;
+    synchronized (connectionPool) {
+      return connection != null ? connection.route() : null;
+    }
   }
 
   public RealConnection connection() {
@@ -371,38 +375,19 @@ public void cancel() {
     }
   }
 
-  public void streamFailed(@Nullable IOException e) {
+  public void releaseStreamForException() {
     synchronized (connectionPool) {
       if (released) throw new IllegalStateException();
+      this.codec = null;
+    }
+  }
 
-      if (e instanceof StreamResetException) {
-        ErrorCode errorCode = ((StreamResetException) e).errorCode;
-        if (errorCode == ErrorCode.REFUSED_STREAM) {
-          // Retry REFUSED_STREAM errors once on the same connection.
-          connection.refusedStreamCount++;
-          if (connection.refusedStreamCount > 1) {
-            connection.noNewStreams = true;
-            route = null;
-          }
-        } else if (errorCode != ErrorCode.CANCEL) {
-          // Keep the connection for CANCEL errors. Everything else wants a fresh connection.
-          connection.noNewStreams = true;
-          route = null;
-        }
-      } else if (connection != null
-          && (!connection.isMultiplexed() || e instanceof ConnectionShutdownException)) {
-        connection.noNewStreams = true;
-
-        // If this route hasn't completed a call, avoid it for new connections.
-        if (connection.successCount == 0) {
-          if (route != null && e != null) {
-            routeSelector.connectFailed(route, e);
-          }
-          route = null;
-        }
+  public void streamFailed(IOException e) {
+    synchronized (connectionPool) {
+      hasStreamFailure = true;
+      if (connection != null) {
+        connection.trackFailure(e);
       }
-
-      this.codec = null;
     }
   }
 
@@ -474,9 +459,14 @@ public Socket releaseAndAcquire(RealConnection newConnection) {
   }
 
   public boolean hasMoreRoutes() {
-    return route != null
-        || (routeSelection != null && routeSelection.hasNext())
-        || routeSelector.hasNext();
+    synchronized (connectionPool) {
+      // Don't recover if it isn't our fault!
+      if (!hasStreamFailure) return false;
+
+      return (connection != null && connection.routeFailureCount == 0)
+          || (routeSelection != null && routeSelection.hasNext())
+          || routeSelector.hasNext();
+    }
   }
 
   @Override public String toString() {
diff --git a/okhttp/src/main/java/okhttp3/internal/http/HttpCodec.java b/okhttp/src/main/java/okhttp3/internal/http/HttpCodec.java
index f0b71e7302..22a9d7679d 100644
--- a/okhttp/src/main/java/okhttp3/internal/http/HttpCodec.java
+++ b/okhttp/src/main/java/okhttp3/internal/http/HttpCodec.java
@@ -19,6 +19,7 @@
 import okhttp3.Headers;
 import okhttp3.Request;
 import okhttp3.Response;
+import okhttp3.internal.connection.RealConnection;
 import okio.Sink;
 import okio.Source;
 
@@ -31,6 +32,9 @@
    */
   int DISCARD_STREAM_TIMEOUT_MILLIS = 100;
 
+  /** Returns the connection that carries this codec. */
+  RealConnection connection();
+
   /** Returns an output stream where the request body can be streamed. */
   Sink createRequestBody(Request request, long contentLength);
 
diff --git a/okhttp/src/main/java/okhttp3/internal/http/RetryAndFollowUpInterceptor.java b/okhttp/src/main/java/okhttp3/internal/http/RetryAndFollowUpInterceptor.java
index e904a67ce1..c6c65d2bbf 100644
--- a/okhttp/src/main/java/okhttp3/internal/http/RetryAndFollowUpInterceptor.java
+++ b/okhttp/src/main/java/okhttp3/internal/http/RetryAndFollowUpInterceptor.java
@@ -81,12 +81,11 @@ public RetryAndFollowUpInterceptor(OkHttpClient client) {
       }
 
       Response response;
-      boolean releaseConnection = true;
+      boolean success = false;
       try {
         response = realChain.proceed(request, transmitter, null);
-        releaseConnection = false;
+        success = true;
       } catch (RouteException e) {
-        releaseConnection = false;
         // The attempt to connect via a route failed. The request will not have been sent.
         if (!recover(e.getLastConnectException(), transmitter, false, request)) {
           throw e.getFirstConnectException();
@@ -95,13 +94,12 @@ public RetryAndFollowUpInterceptor(OkHttpClient client) {
       } catch (IOException e) {
         // An attempt to communicate with a server failed. The request may have been sent.
         boolean requestSendStarted = !(e instanceof ConnectionShutdownException);
-        releaseConnection = false;
         if (!recover(e, transmitter, requestSendStarted, request)) throw e;
         continue;
       } finally {
-        // We're throwing an unchecked exception. Release any resources.
-        if (releaseConnection) {
-          transmitter.streamFailed(null);
+        // The network call threw an exception. Release any resources.
+        if (!success) {
+          transmitter.releaseStreamForException();
         }
       }
 
@@ -153,8 +151,6 @@ public RetryAndFollowUpInterceptor(OkHttpClient client) {
    */
   private boolean recover(IOException e, Transmitter transmitter,
       boolean requestSendStarted, Request userRequest) {
-    transmitter.streamFailed(e);
-
     // The application layer has forbidden retries.
     if (!client.retryOnConnectionFailure()) return false;
 
diff --git a/okhttp/src/main/java/okhttp3/internal/http1/Http1Codec.java b/okhttp/src/main/java/okhttp3/internal/http1/Http1Codec.java
index 3a4fd926e4..33c9730e37 100644
--- a/okhttp/src/main/java/okhttp3/internal/http1/Http1Codec.java
+++ b/okhttp/src/main/java/okhttp3/internal/http1/Http1Codec.java
@@ -98,6 +98,10 @@ public Http1Codec(OkHttpClient client, RealConnection realConnection, BufferedSo
     this.sink = sink;
   }
 
+  @Override public RealConnection connection() {
+    return realConnection;
+  }
+
   @Override public Sink createRequestBody(Request request, long contentLength) {
     if ("chunked".equalsIgnoreCase(request.header("Transfer-Encoding"))) {
       // Stream a request body of unknown length.
diff --git a/okhttp/src/main/java/okhttp3/internal/http2/Http2Codec.java b/okhttp/src/main/java/okhttp3/internal/http2/Http2Codec.java
index bc271d5d7f..afbc6c6d6a 100644
--- a/okhttp/src/main/java/okhttp3/internal/http2/Http2Codec.java
+++ b/okhttp/src/main/java/okhttp3/internal/http2/Http2Codec.java
@@ -29,6 +29,7 @@
 import okhttp3.Response;
 import okhttp3.internal.Internal;
 import okhttp3.internal.Util;
+import okhttp3.internal.connection.RealConnection;
 import okhttp3.internal.http.HttpCodec;
 import okhttp3.internal.http.HttpHeaders;
 import okhttp3.internal.http.RequestLine;
@@ -83,12 +84,15 @@
       UPGRADE);
 
   private final Interceptor.Chain chain;
+  private final RealConnection realConnection;
   private final Http2Connection connection;
   private volatile Http2Stream stream;
   private final Protocol protocol;
   private volatile boolean canceled;
 
-  public Http2Codec(OkHttpClient client, Interceptor.Chain chain, Http2Connection connection) {
+  public Http2Codec(OkHttpClient client, RealConnection realConnection, Interceptor.Chain chain,
+      Http2Connection connection) {
+    this.realConnection = realConnection;
     this.chain = chain;
     this.connection = connection;
     this.protocol = client.protocols().contains(Protocol.H2_PRIOR_KNOWLEDGE)
@@ -96,6 +100,10 @@ public Http2Codec(OkHttpClient client, Interceptor.Chain chain, Http2Connection
         : Protocol.HTTP_2;
   }
 
+  @Override public RealConnection connection() {
+    return realConnection;
+  }
+
   @Override public Sink createRequestBody(Request request, long contentLength) {
     return stream.getSink();
   }
diff --git a/okhttp/src/main/java/okhttp3/internal/ws/RealWebSocket.java b/okhttp/src/main/java/okhttp3/internal/ws/RealWebSocket.java
index 655607d2ea..634fb9b983 100644
--- a/okhttp/src/main/java/okhttp3/internal/ws/RealWebSocket.java
+++ b/okhttp/src/main/java/okhttp3/internal/ws/RealWebSocket.java
@@ -201,7 +201,6 @@ public void connect(OkHttpClient client) {
         }
 
         // Promote the HTTP streams into web socket streams.
-        transmitter.noNewStreamsOnConnection();
         Streams streams = transmitter.newWebSocketStreams();
 
         // Process all web socket messages.
